Bug 1553398 (CVE-2018-1000122) - CVE-2018-1000122 curl: RTSP RTP buffer over-read
Summary: CVE-2018-1000122 curl: RTSP RTP buffer over-read
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2018-1000122
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1555208 1555207 1555209 1555210 1555221 1565032
Blocks: 1552634
TreeView+ depends on / blocked
 
Reported: 2018-03-08 19:29 UTC by Pedro Sampaio
Modified: 2019-09-29 14:35 UTC (History)
24 users (show)

Fixed In Version: curl 7.59.0
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-06-10 10:17:20 UTC


Attachments (Terms of Use)
upstream patch (1.30 KB, patch)
2018-03-08 19:38 UTC, Pedro Sampaio
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:3157 None None None 2018-10-30 07:43:38 UTC
Red Hat Product Errata RHSA-2018:3558 None None None 2018-11-13 08:35:36 UTC
Red Hat Product Errata RHSA-2019:1543 None None None 2019-06-18 19:09:09 UTC

Description Pedro Sampaio 2018-03-08 19:29:14 UTC
curl can be tricked into copying data beyond end of its heap based buffer.

When asked to transfer an RTSP URL, curl could calculate a wrong data length
to copy from the read buffer. The memcpy call would copy data from the heap
following the buffer to a storage area that would subsequently be delivered to
the application (if it didn't cause a crash). We've managed to get it to reach
several hundreds bytes out of range.

This could lead to information leakage or a denial of service for the
application if the server offering the RTSP data can trigger this.

Comment 2 Pedro Sampaio 2018-03-08 19:38:47 UTC
Created attachment 1405982 [details]
upstream patch

Comment 3 Adam Mariš 2018-03-14 07:29:27 UTC
Acknowledgments:

Name: the Curl project
Upstream: Max Dymond

Comment 4 Adam Mariš 2018-03-14 07:29:38 UTC
External References:

https://curl.haxx.se/docs/adv_2018-b047.html

Comment 5 Adam Mariš 2018-03-14 07:34:04 UTC
Created mingw-curl tracking bugs for this issue:

Affects: fedora-all [bug 1555207]


Created curl tracking bugs for this issue:

Affects: fedora-all [bug 1555209]


Created mingw-curl tracking bugs for this issue:

Affects: epel-7 [bug 1555208]

Comment 8 Cedric Buissart 🐶 2018-03-14 09:56:47 UTC
Upstream fix:
 readwrite: make sure excess reads don't go beyond buffer end
https://github.com/curl/curl/commit/d52dc4760f

Comment 12 errata-xmlrpc 2018-10-30 07:43:27 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2018:3157 https://access.redhat.com/errata/RHSA-2018:3157

Comment 13 errata-xmlrpc 2018-11-13 08:35:26 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.6 EUS

Via RHSA-2018:3558 https://access.redhat.com/errata/RHSA-2018:3558

Comment 14 errata-xmlrpc 2019-06-18 19:09:08 UTC
This issue has been addressed in the following products:

  JBoss Core Services Apache HTTP Server 2.4.29 SP2

Via RHSA-2019:1543 https://access.redhat.com/errata/RHSA-2019:1543


Note You need to log in before you can comment on or make changes to this bug.